Loading...
Searching...
No Matches
AVBufferPool
libavutil » Data Structures

AVBufferPool is an API for a lock-free thread-safe pool of AVBuffers. More...

## Typedefs

typedef struct AVBufferPool | AVBufferPool
| The buffer pool.

## Functions

AVBufferPool * | av_buffer_pool_init (size_t size, AVBufferRef *(*alloc)(size_t size))
| Allocate and initialize a buffer pool.
AVBufferPool * | av_buffer_pool_init2 (size_t size, void *opaque, AVBufferRef *(*alloc)(void *opaque, size_t size), void(*pool_free)(void *opaque))
| Allocate and initialize a buffer pool with a more complex allocator.
void | av_buffer_pool_uninit (AVBufferPool **pool)
| Mark the pool as being available for freeing.
AVBufferRef * | av_buffer_pool_get (AVBufferPool *pool)
| Allocate a new AVBuffer, reusing an old buffer from the pool when available.
void * | av_buffer_pool_buffer_get_opaque (const AVBufferRef *ref)
| Query the original opaque parameter of an allocated buffer in the pool.

## Detailed Description

AVBufferPool is an API for a lock-free thread-safe pool of AVBuffers.

Frequently allocating and freeing large buffers may be slow. AVBufferPool is meant to solve this in cases when the caller needs a set of buffers of the same size (the most obvious use case being buffers for raw video or audio frames).

At the beginning, the user must call av_buffer_pool_init() to create the buffer pool. Then whenever a buffer is needed, call av_buffer_pool_get() to get a reference to a new buffer, similar to av_buffer_alloc(). This new reference works in all aspects the same way as the one created by av_buffer_alloc(). However, when the last reference to this buffer is unreferenced, it is returned to the pool instead of being freed and will be reused for subsequent av_buffer_pool_get() calls.

When the caller is done with the pool and no longer needs to allocate any new buffers, av_buffer_pool_uninit() must be called to mark the pool as freeable. Once all the buffers are released, it will automatically be freed.

Allocating and releasing buffers with this API is thread-safe as long as either the default alloc callback is used, or the user-supplied one is thread-safe.

## Typedef Documentation

## AVBufferPool

typedef struct AVBufferPool AVBufferPool

The buffer pool.

This structure is opaque and not meant to be accessed directly. It is allocated with av_buffer_pool_init() and freed with av_buffer_pool_uninit().

Definition at line 255 of file buffer.h.

## Function Documentation

## av_buffer_pool_init()

AVBufferPool * av_buffer_pool_init | ( | size_t | size,
|  | AVBufferRef *(* | alloc )(size_t size) )

Allocate and initialize a buffer pool.

Parameters

  size | size of each buffer in this pool
  alloc | a function that will be used to allocate new buffers when the pool is empty. May be NULL, then the default allocator will be used (av_buffer_alloc()).

Returns
  newly created buffer pool on success, NULL on error.

## av_buffer_pool_init2()

AVBufferPool * av_buffer_pool_init2 | ( | size_t | size,
|  | void * | opaque,
|  | AVBufferRef *(* | alloc )(void *opaque, size_t size),
|  | void(* | pool_free )(void *opaque) )

Allocate and initialize a buffer pool with a more complex allocator.

Parameters

  size | size of each buffer in this pool
  opaque | arbitrary user data used by the allocator
  alloc | a function that will be used to allocate new buffers when the pool is empty. May be NULL, then the default allocator will be used (av_buffer_alloc()).
  pool_free | a function that will be called immediately before the pool is freed. I.e. after av_buffer_pool_uninit() is called by the caller and all the frames are returned to the pool and freed. It is intended to uninitialize the user opaque data. May be NULL.

Returns
  newly created buffer pool on success, NULL on error.

## av_buffer_pool_uninit()

void av_buffer_pool_uninit | ( | AVBufferPool ** | pool | ) |

Mark the pool as being available for freeing.

It will actually be freed only once all the allocated buffers associated with the pool are released. Thus it is safe to call this function while some of the allocated buffers are still in use.

Parameters

  pool | pointer to the pool to be freed. It will be set to NULL.

## av_buffer_pool_get()

AVBufferRef * av_buffer_pool_get | ( | AVBufferPool * | pool | ) |

Allocate a new AVBuffer, reusing an old buffer from the pool when available.

This function may be called simultaneously from multiple threads.

Returns
  a reference to the new buffer on success, NULL on error.

## av_buffer_pool_buffer_get_opaque()

void * av_buffer_pool_buffer_get_opaque | ( | const AVBufferRef * | ref | ) |

Query the original opaque parameter of an allocated buffer in the pool.

Parameters

  ref | a buffer reference to a buffer returned by av_buffer_pool_get.

Returns
  the opaque parameter set by the buffer allocator function of the buffer pool.

Note
  the opaque parameter of ref is used by the buffer pool implementation, therefore you have to use this function to access the original opaque parameter of an allocated buffer.